use strict;
use vars qw($VERSION %IRSSI);

use Irssi;
use Irssi::Irc;

$VERSION = '1.00';
%IRSSI = (
        authors     => 'Tim Daniel Schumacher',
        contact     => 'tim@we-are-teh-b.org',
        name        => 'Avatarscript for KVIrc',
        description =>  'This script sends an avatar' .
                        ' reply with an URL of your' .
                        ' avatar. You have to set the' .
                        ' avatar variable with the URL' .
                        ' of your avatar.',
        license     => 'Public Domain',
);

Irssi::settings_add_str(
        'misc', 'avatar', 'http://www.irssi.org/gfx/irssilogo.jpg'
);

sub avatar_reply {
        my ($server, $args, $nick, $addr, $target) = @_;
        if ($args eq "AVATAR" and $target ne $nick) {
                my $avatar = Irssi::settings_get_str("avatar");
                if ($avatar ne "") {
                        Irssi::active_win()->printformat(MSGLEVEL_CRAP, 'avatar', "Sending my avatar to $nick");
                        $server->command("NOTICE $nick \001AVATAR $avatar");
                        Irssi::signal_stop();
                }
        }

}

Irssi::signal_add('default ctcp msg','avatar_reply');
Irssi::theme_register(['avatar', '[%gAvatar%n] $0-']);
